<template>
  <div class="doc-example">
    <rui-toolbars class="doc-example__actions">
      <rui-toolbar>
        <rui-button icon="cog"
                    text
                    :active="showOptions"
                    title="Preview options"
                    @click="showOptions = !showOptions" />
      </rui-toolbar>

      <div v-show="showOptions">
        <rui-toolbar label="Preview size">
          <rui-dropdown :caption="size">
            <rui-menu-item :active="size === 'tiny'" caption="&lt; small" @click="size='tiny'" />
            <rui-menu-item :active="size === 'small'" caption="small" @click="size='small'" />
            <rui-menu-item :active="size === 'medium'" caption="medium" @click="size='medium'" />
            <rui-menu-item :active="size === 'large'" caption="large" @click="size='large'" />
            <rui-menu-item :active="size === 'default'" caption="default" @click="size='default'" />
          </rui-dropdown>
        </rui-toolbar>

        <rui-toolbar label="Outline">
          <rui-button :caption="outline ? 'Yes' : 'No'" @click="outline = !outline" />
        </rui-toolbar>

        <rui-toolbar label="Theme">
          <rui-button :caption="isDarkTheme ? 'Dark' : 'Light'" @click="isDarkTheme = !isDarkTheme" />
        </rui-toolbar>

        <rui-toolbar label="Background">
          <rui-button :caption="checkedBackground ? 'Checkered' : 'Default'" @click="checkedBackground = !checkedBackground" />
        </rui-toolbar>

        <rui-toolbar label="Padding">
          <rui-button :caption="padding ? 'Yes' : 'No'" @click="padding = !padding" />
        </rui-toolbar>
      </div>
    </rui-toolbars>

    <div class="doc-example__wrapper">
      <div class="doc-example__content rui" :class="previewCSS">
        <slot />
      </div>
    </div>

    <div v-if="$slots.aside" class="doc-example__aside"><slot name="aside" /></div>
  </div>
</template>
<script>

export default {
  name: 'ExampleWrapper',
  data () {
    return {
      showOptions: false,
      // Preview options
      size: 'default',
      outline: false,
      isDarkTheme: true,
      checkedBackground: false,
      padding: false,
    }
  },
  computed: {
    previewCSS () {
      return [
        this.isDarkTheme ? 'rui-theme--dark' : 'rui-theme--light',
        this.size && `doc-example__content--${this.size}`,
        this.checkedBackground && 'doc-example__content--checkered',
        this.outline && 'doc-example__content--outline',
        this.padding && 'doc-example__content--padded',
      ]
    },
  },
}
</script>
